#include <iostream>
#include <vector>
using namespace std;

int INF = -1000000;

struct Tree{

	Tree *left, *right;
	int start, end;
	int value;

	Tree(int l, int r):
		start(l), end(r), left(NULL), right(NULL), value(INF){}

	void build(vector<int> &v){
		if(start == end){
			value = v[start];
		}else{
			int mid = (start + end) >> 1;
			left = new Tree(start, mid);
			right = new Tree(mid + 1, end);
			left -> build(v);
			right -> build(v);
			value = max (left -> value, right -> value);
		}
	}

	int query(int l, int r){
		if(r < start || end < l) return INF;
		if(l <= start && end <= r) return value;
		return max(left -> query(l,r), right -> query(l, r));
	}
};

void solve(){
	int n;
	cin >> n;

	vector<int> v(n+1);
	int data;
	for(int i = 1; i <= n; i++){
		cin >> v[i];
	}

	Tree *segmentTree = new Tree(1,n);
	segmentTree -> build(v);

	int q;
	cin >> q;
	int l, r;
	for(int i = 0; i < q; i++){
		cin >> l >> r;
		cout << segmentTree -> query(l+1 , r+1) << '\n';
	}

}

int main(){
	solve();
	return 0;
}